(* 
   File   : /home/cvs/cvsroot/projects/visualstate/scope/CodGen.sml,v
   Comment: Common module for all code generators
   Release: scope-0-15_final 

     Copyright (C) 2001-2002 Andrzej Wasowski
     
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

   CodGen.sml,v 1.12 2002/11/09 14:38:11 wasowski Exp
*)

structure CodGen = struct 

  open Cppish
  infix 0 << <<< <<> (* some fun with C++ style IO *)

  type codsumer = TextIO.outstream (* code consumer *)

  type codgen = codsumer -> codsumer

  (* concatenating string generators *)

  fun op-- (cg1,cg2) = op o (cg2,cg1);
  infix 3 --;

  (* end of code : empty code generator *)

  fun eoc os = os


  (* creates a code generator which prepends given string list to given
     output *)

  fun cg (lst :string list) :codgen = fn os => os <<< lst

  fun sg (s :string) :codgen = fn os => os << s

  fun ig (i :int)    :codgen = fn os => os << Int.toString i

  fun concat (lst :codgen list) :codgen = foldl (fn (x,e) => e -- x) eoc lst
  
  (* end of line *)

  val eol = sg "\n"



end
