(*
   File   : /home/cvs/cvsroot/projects/visualstate/scope/Normalise.sig,v
   Comment: Normalise Absyn model.
   Release: scope-0-15_final

     Copyright (C) 2001-2003 Andrzej Wasowski
     
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

   NOTES:

   Normalisation currently includes: 

   1. removal of single children orstates (empty orstates are illegal at all)
   
   Normalise.sig,v 1.11 2003/07/15 14:38:39 wasowski Exp
*)

signature Normalise = sig

	val normalise  : ('aor,'atr) Absyn.model -> ('aor,'atr) Absyn.model
	
	val degroup    : Absyn.evgroup Absyn.env -> 'atr Absyn.tran  
				-> 'atr Absyn.tran list

	val degroup_all: Absyn.evgroup Absyn.env -> 'atr Absyn.tran list 
				-> 'atr Absyn.tran list

	val degroup_sys: ('aor,'atr) Absyn.system -> ('aor,'atr) Absyn.system

	val pull_defs : Absyn.denv * 'aor Absyn.hierarchy 
				-> Absyn.denv * 'aor Absyn.hierarchy

	val push_defs : Absyn.denv * 'aor Absyn.hierarchy 
				-> Absyn.denv * 'aor Absyn.hierarchy 

	val rmRedundantTgts : 'aor Absyn.hierarchy -> 'atr Absyn.tran 
				-> 'atr Absyn.tran
	
	val rmRedundantTgts_sys: ('aor,'atr) Absyn.system 
			-> ('aor,'atr) Absyn.system

(*
	[normalise] is not implemented

	[pull_defs h] restructures hierarchy pulling the initial state
	(initial child) of each or-state to be the first on the children
	list. This slightly violates our semantics (only because this
	semantics is fully deterministic and assumes a single ordering). This
	is perfectly legal in widely accepted semantic definitions for
	statecharts (like UML, and probably Harel). This is used by CodGenC1.
	Reordering should be done before we start to generate the array for
	hierarchy (otherwise this disturbs the canonical preorder addressing
	of states).

	[push_defs h] is similar to pull_defs, but makes sure that default
	state is the last one on the list of states. This is to be used with
	preorder, R->L addressing.
*)
end
