(* 
   File   : /home/cvs/cvsroot/projects/visualstate/scope/util/Typeset.sig,v
   Comment: A set of operations on text useful in automatic formating of 
            programs. Some are vsr specific but I keep them still here.
   Release: scope-0-15_final

     Copyright (C) 2001-2002 Andrzej Wasowski
     
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

   Typeset.sig,v 1.1 2002/12/11 11:56:25 wasowski Exp
*)


signature Typeset = sig

  val indin  : string -> string
  val indent : string -> string -> string

  val prefix : string -> string -> string
  val suffix : string -> string -> string

  val bothfix : string -> string -> string -> string
  val enclose : string -> string -> string

  val paren   : string -> string
  val bracket : string -> string
  val embrace : string -> string
  val quote   : string -> string
  val angle   : string -> string

  val repeat : string -> int -> string
  val spaces : int -> string
  val padl   : int -> string -> string

  val vsr_block         : 
	string -> string -> string list -> string list -> string list
  val vsr_special_block : 
	string -> string -> string list -> string list -> string list

  val vsr_block_trans         : 
	string -> ('a -> string list -> string list) -> string -> 'a list -> string list
	-> string list

  val vsr_special_block_trans : 
	string -> ('a -> string list -> string list) -> string -> 'a list -> string list
	-> string list

  val inserts     : string -> string list -> string list -> string list
  val join_commas : string list -> string list -> string list
  val join_dots   : string list -> string list -> string list
  val join_blanks : string list -> string list -> string list

  val c_params : string list -> string list -> string list
  

end 
